
PROGRAM CHGLINKS;

(* VERSION 1.00 POUR WINDOWS 32 BITS.

   COMPILATEUR          : VIRTUAL PASCAL 2.1
   DATE DE CREATION     : 06-10-2005
   DERNIERE MISE A JOUR : 06-10-2005

   MODIFICATION AUTOMATIQUE DES CHEMINS D'ACCES DE TOUS LES RACCOURCIS PRESENTS DANS UN PROFIL LOCAL *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                              DIRECTIVES DE COMPILATION                                                 *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{&Use32+}
{$DEFINE WIN32}
{$DEFINE WINDOWS}

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                               UNITES ET DLL UTILISEES                                                  *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Uses STRINGS,    (* CHAINES AZT *)
     WINCRT,     (* CONSOLE *)
     WINDOWS,    (* API WINDOWS *)
     WINSHELL;   (* OBJETS COM *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                   CONSTANTES NON TYPEES (DIRECTIVES AU COMPILATEUR)                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Const NbRegles = 27;        (* NOMBRE DE REGLES DE MODIFICATION A APPLIQUER *)
      Masque = '\*.*';      (* MASQUE DU NOM DE FICHIER A RECHERCHER *)
      Extension = '.LNK';   (* EXTENSION A RECHERCHER DANS LES NOMS DE FICHIERS *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                   TYPES DE DONNEES                                                     *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Type tExtrait = Array [0..MAX_PATH] of Char;           (* EXTRAIT A RECHERCHER DANS LES *.LNK POUR REMPLACEMENT *)
     tRegles = Array [1..NbRegles,1..2] of tExtrait;   (* TABLEAU DES REGLES DE MODIFICATION *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                   CONSTANTES TYPEES                                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                   VARIABLES GLOBALES                                                   *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Var Regles : tRegles;                              (* REGLES DE MODIFICATION A APPLIQUER *)
    Index : Word;                                  (* INDEX DANS LE TABLEAU Regles *)
    BufferChemin : Array [0..MAX_PATH] of Char;    (* BUFFER DE CONSTRUCTION D'UN CHEMIN *)
    hRes : hResult;                                (* RESULTAT DES FONCTIONS COM *)
    Memory : PIMalloc;                             (* MEMOIRE ALLOUEE PAR SHgetMalloc *)
    pIdL : LPITEMIDLIST;                           (* RESULTAT DE SHGetSpecialFolderLocation *)
    SL : pIShellLink;                              (* ADRESSE DE L'INTERFACE IShellLink *)
    PF : pIPersistFile;                            (* ADRESSE DE L'INTERFACE IPersistFile *)
    w : Array [0..MAX_PATH] of WChar;              (* CHAINE DE TRAVAIL UNICODE *)
    szChemin : Array [0..MAX_PATH] of Char;        (* CHEMIN CONTENU DANS LE RACCOURCI *)
    CheminUp : Array [0..MAX_PATH] of Char;        (* VERSION EN MAJUSCULES D'UN CHEMIN *)
    RegleUp : Array [0..MAX_PATH] of Char;         (* VERSION EN MAJUSCULES D'UNE REGLE *)
    Copie : Array [0..MAX_PATH] of Char;           (* COPIE DE TRAVAIL D'UN CHEMIN AVANT MODIFICATION *)
    Win32FindData : tWin32FindData;                (* STRUCTURE DE RECHERCHE *)
    AncienCurseur : hCursor;                       (* CURSEUR D'ORIGINE *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                 PROCEDURES ET FONCTIONS                                                *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Function APPLICATION_REGLES (Chemin : pChar) : Boolean;
(* MODIFICATION DE CHEMIN CONFORMEMENT AUX REGLES - RENVOIE True SI MODIFICATION *)
Var Modification, Annuler : Boolean;   (* INTERRUPTEURS DE BOUCLE *)
    Position : pChar;                  (* POSITION DE LA CHAINE A RECHERCHER DANS LE CHEMIN *)
    i : Word;                          (* INDEX DANS LE CHEMIN *)
Begin
  Modification := False;
  StrCopy(Copie,Chemin);
  StrCopy(CheminUp,Chemin);
  StrUpper(CheminUp);
  Annuler := False;
  Index := 1;
  while (Index <= NbRegles) and (not Modification) and (not Annuler) do
    begin
      StrCopy(RegleUp,Regles[Index,1]);
      StrUpper(RegleUp);
      Position := StrPos(CheminUp,RegleUp);
      if Position <> Nil
         then   (* EXTRAIT TROUVE *)
           begin
             i := Word(Position - CheminUp);
             Chemin[i] := #0;
             StrCat(Chemin,Regles[Index,2]);
             Inc(i,StrLen(Regles[Index,1]));
             StrCat(Chemin,@Copie[i]);
             Modification := True;
           end
         else
           Inc(Index);
    end;
  APPLICATION_REGLES := Modification;
End;

Procedure RECHERCHE_RECURSIVE (Dossier : pChar);
(* PROCEDURE RECURSIVE DE RECHERCHE DES FICHIERS *.LNK DANS UN DOSSIER ET DANS SES SOUS-DOSSIERS *)
Var hRecherche : tHandle;           (* HANDLE DE LA SESSION DE RECHERCHE DE RACCOURCIS *)
    FindData : tWin32FindData;      (* STRUCTURE DE RESULTAT DE FindFirstFile *)
    NomDossier : pChar;             (* NOM DU DOSSIER ACTUEL SAUVEGARDE SUR LE TAS *)
    Chemin : pChar;                 (* CHEMIN COMPLET DE RECHERCHE SAUVEGARDE SUR LE TAS *)
    ContinuerRecherche : Boolean;   (* INDIQUE SI LA RECHERCHE PEUT ETRE POURSUIVIE *)
    ContinuerFichier : Boolean;     (* INDIQUE SI LE TRAITEMENT DU RACCOURCI PEUT ETRE POURSUIVI *)
    ModifFichier : Boolean;         (* INDIQUE SI UN RACCOURCI A ETE MODIFIE *)
    ModifChemin : Boolean;          (* INDIQUE SI UN CHEMIN A ETE MODIFIE *)
Begin
  Writeln(Dossier);
  NomDossier := StrNew(Dossier);   (* SAUVEGARDE DU NOM DE DOSSIER SUR LE TAS *)
  StrCopy(BufferChemin,Dossier);
  StrCat(BufferChemin,Masque);
  Chemin := StrNew(BufferChemin);   (* SAUVEGARDE DU CHEMIN COMPLET SUR LE TAS *)
  hRecherche := FindFirstFile(Chemin,FindData);
  if hRecherche <> Invalid_Handle_Value
     then
       begin
         ContinuerRecherche := True;
         while ContinuerRecherche do
           begin
             if (FindData.dwFileAttributes and File_Attribute_Directory) <> 0
                then   (* IL S'AGIT D'UN NOM DE DOSSIER *)
                  begin
                    if FindData.cFileName[0] <> '.'
                       then
                         begin
                           StrCopy(BufferChemin,NomDossier);
                           StrCat(BufferChemin,'\');
                           StrCat(BufferChemin,FindData.cFileName);
                           RECHERCHE_RECURSIVE(BufferChemin);
                         end;
                  end
                else
                  if StrPos(StrUpper(FindData.cFileName),Extension) <> Nil
                     then   (* IL S'AGIT D'UN FICHIER DE RACCOURCI *)
                       begin
                         WriteLn('-->',FindData.cFileName);
                         StrCopy(BufferChemin,NomDossier);
                         StrCat(BufferChemin,'\');
                         StrCat(BufferChemin,FindData.cFileName);
                         (* CONVERSION DU CHEMIN EN UNICODE *)
                         MultiByteToWideChar(CP_ACP,0,BufferChemin,-1,@w,SizeOf(w));
                         (* CHARGEMENT DU RACCOURCI *)
                         hRes := PF^.Vtbl^.Load(PF,@w,STGM_READWRITE);
                         if hRes = s_OK
                            then
                              begin
                                ContinuerFichier := True;
                                ModifFichier := False;
                                ContinuerFichier := (SL^.Vtbl^.GetPath(SL,szChemin,SizeOf(szChemin),Win32FindData,SLGP_RAWPATH) = s_OK);
                                if ContinuerFichier
                                   then
                                     begin
                                       ModifChemin := APPLICATION_REGLES(szChemin);
                                       if ModifChemin
                                          then
                                            begin
                                              ContinuerFichier := (SL^.Vtbl^.SetPath(SL,szChemin) = s_OK);
                                              if not ContinuerFichier
                                                 then
                                                   WriteLn('     Erreur de modification du chemin de la cible');
                                            end;
                                       ModifFichier := ModifFichier or ModifChemin;
                                     end
                                   else
                                     Writeln('     Erreur de lecture du nom long du chemin');
                                if ContinuerFichier
                                   then
                                     begin
                                       ContinuerFichier := (SL^.Vtbl^.GetWorkingDirectory(SL,szChemin,SizeOf(szChemin)) = s_OK);
                                       if ContinuerFichier
                                          then
                                            begin
                                              ModifChemin := APPLICATION_REGLES(szChemin);
                                              if ModifChemin
                                                 then
                                                   begin
                                                     ContinuerFichier := (SL^.Vtbl^.SetWorkingDirectory(SL,szChemin) = s_OK);
                                                     if not ContinuerFichier
                                                        then
                                                          WriteLn('     Erreur de modification du dossier de travail');
                                                   end;
                                              ModifFichier := ModifFichier or ModifChemin;
                                            end
                                          else
                                            Writeln('     Erreur de lecture du dossier de travail');
                                     end;
                                if ContinuerFichier
                                   then
                                     begin
                                       ContinuerFichier := (SL^.Vtbl^.GetArguments(SL,szChemin,SizeOf(szChemin)) = s_OK);
                                       if ContinuerFichier
                                          then
                                            begin
                                              ModifChemin := APPLICATION_REGLES(szChemin);
                                              if ModifChemin
                                                 then
                                                   begin
                                                     ContinuerFichier := (SL^.Vtbl^.SetArguments(SL,szChemin) = s_OK);
                                                     if not ContinuerFichier
                                                        then
                                                          WriteLn('     Erreur de modification des arguments');
                                                   end;
                                              ModifFichier := ModifFichier or ModifChemin;
                                            end
                                          else
                                            Writeln('     Erreur de lecture des arguments');
                                     end;
                                if ContinuerFichier and ModifFichier
                                   then   (* SAUVEGARDE DU RACCOURCI *)
                                     begin
                                       hRes := PF^.Vtbl^.Save(PF,Nil,False);
                                       if hRes = s_OK
                                          then
                                            WriteLn('     Modifications effectues')
                                          else
                                            WriteLn('     Erreur d''enregistrement (Save)');
                                     end;
{
ReadLn;
}
                              end
                            else
                              WriteLn('     Erreur de chargement du raccourci (Load)');
                       end;
             ContinuerRecherche := FindNextFile(hRecherche,FindData);
           end;
         FindClose(hRecherche);
       end;
  if NomDossier <> Nil
     then
       StrDispose(NomDossier);
  if Chemin <> Nil
     then
       StrDispose(Chemin);
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  PROGRAMME PRINCIPAL                                                   *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

BEGIN
  ScreenSize.X := 128;
  WriteLn;
  WriteLn('------------------------------------------------------------');
  WriteLn(' ChgLinks 1.00 - LPJJl Software 2005');
  WriteLn('------------------------------------------------------------');
  WriteLn(' Migration vers Novell 6 - Serveur site Saint-L'#233'onard');
  WriteLn(' Modification automatique des raccourcis des profils locaux');
  WriteLn('------------------------------------------------------------');
  WriteLn('Attention :');
  WriteLn('1. A n''utiliser qu''APRES la migration vers Novell 6.');
  WriteLn('2. Le traitement de certains raccourcis peut prendre plusieurs minutes !');
  WriteLn;
  Write('Pressez Enter pour commencer...');
  ReadLn;
  WriteLn;
  FillChar(Regles,SizeOf(Regles),0);
  StrCopy(Regles[1,1],'\DIS\DBO-BDR');        StrCopy(Regles[1,2],'\AIK-CIA');
  StrCopy(Regles[2,1],'\DIS\DPL-OFFR');       StrCopy(Regles[2,2],'\CSD-SCA\PLC-CPL\PERS');
  StrCopy(Regles[3,1],'\DIS\DPL-SECR');       StrCopy(Regles[3,2],'\CSD-SCA\PLC-CPL\LOG');
  StrCopy(Regles[4,1],'\DIS\STDDOC');         StrCopy(Regles[4,2],'\CSD-SCA\STDDOC');
  StrCopy(Regles[5,1],'\DIS\OIPG-PCO');       StrCopy(Regles[5,2],'\CSD-SCA\PLC-CPL\BU');
  StrCopy(Regles[6,1],'\DIS\OPS-OFFR');       StrCopy(Regles[6,2],'\CSD-SCA\BO-AP');
  StrCopy(Regles[7,1],'\DIS\OPS-SECR');       StrCopy(Regles[7,2],'\CSD-SCA\OCS-CAO');
  StrCopy(Regles[8,1],'\DIS\SRT');            StrCopy(Regles[8,2],'\CSD-SCA\PLC-CPL\ADMINISTRATION');
  StrCopy(Regles[9,1],'\DIS\COMC');           StrCopy(Regles[9,2],'\CSD-SCA\COMC-CCOM');
  StrCopy(Regles[10,1],'\DIS\LOG\VEH');       StrCopy(Regles[10,2],'\DMLS\VTG-VEH_SRT');
  StrCopy(Regles[11,1],'\DIS\LOG\MAGASIN');   StrCopy(Regles[11,2],'\DMLS\MAG\MAGASIN');
  StrCopy(Regles[12,1],'\DIS\LOG\MAG');       StrCopy(Regles[12,2],'\DMLS\MAG');
  StrCopy(Regles[13,1],'\DIS\LOG\ARMEMENT');  StrCopy(Regles[13,2],'\DMLS\BEW-ARM');
  StrCopy(Regles[14,1],'\DIS\LOG');           StrCopy(Regles[14,2],'\DMLS\STDDOC');
  StrCopy(Regles[15,1],'\BOB\SRT\NOTES');     StrCopy(Regles[15,2],'\GDA-SJA\DIRECTION\COURRIER');
  StrCopy(Regles[16,1],'\BOB\SRT\COURROUT');  StrCopy(Regles[16,2],'\GDA-SJA\DIRECTION\COURROUT');
  StrCopy(Regles[17,1],'\BOB\DIRJU');         StrCopy(Regles[17,2],'\GDA-SJA\DIRECTION\DIRJU');
  StrCopy(Regles[18,1],'\BOB\ADMIN\BURGEST'); StrCopy(Regles[18,2],'\GDA-SJA\DIRECTION\BUR_GEST');
  StrCopy(Regles[19,1],'\BOB\COMDO\BUR_OPS'); StrCopy(Regles[19,2],'\GDA-SJA\DIRECTION\BUR_OPS');
  StrCopy(Regles[20,1],'\BOB\OND-REC3');      StrCopy(Regles[20,2],'\GDA-SJA\DIV_GB');
  StrCopy(Regles[21,1],'\BOB\OND-REC6');      StrCopy(Regles[21,2],'\GDA-SJA\DIV_STUPS');
  StrCopy(Regles[22,1],'\BOB\OND-REC1');      StrCopy(Regles[22,2],'\GDA-SJA\DIV_OCT');
  StrCopy(Regles[23,1],'\BOB\OND-REC4');      StrCopy(Regles[23,2],'\GDA-SJA\DIV_TEH');
  StrCopy(Regles[24,1],'\BOB\OND-REC5');      StrCopy(Regles[24,2],'\GDA-SJA\SIOP');
  StrCopy(Regles[25,1],'\BOB\OND-REC7');      StrCopy(Regles[25,2],'\GDA-SJA\DIV_BIENS');
  StrCopy(Regles[26,1],'\BOB\ALG-GEN');       StrCopy(Regles[26,2],'\GDA-SJA\COMMUNS');
  StrCopy(Regles[27,1],'\BOB\STDDOC');        StrCopy(Regles[27,2],'\GDA-SJA\DOCUMENTATION');
  Write('Initialisation de la librairie des objets COM : ');
  hRes := CoInitialize(Nil);
  if hRes = s_OK
     then
       begin
         WriteLn('OK');
         Write('Initialisation de l''interface IShellLink : ');
         hRes := CoCreateInstance(CLSID_ShellLink,Nil,CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER,IID_IShellLink,SL);
         if hRes = s_OK
            then
              begin
                WriteLn('OK');
                Write('Initialisation de l''interface IPersistFile : ');
                hRes := SL^.Vtbl^.QueryInterface(SL,IID_IPersistFile,PF);
                if hRes = s_OK
                   then
                     begin
                       WriteLn('OK');
                       WriteLn;
                       AncienCurseur := SetCursor(LoadCursor(0,idc_Wait));
                       (* 1. RACCOURCIS DE L'UTILISATEUR COURANT *)
                       WriteLn('-----------');
                       WriteLn(' 1. Bureau ');
                       WriteLn('-----------');
                       Memory := Nil;
                       pIdL := Nil;
                       if SHGetMalloc(@Memory) = NOERROR
                          then
                            begin
                              SHGetSpecialFolderLocation(0,CSIDL_DESKTOPDIRECTORY,pIdL);
                              if pIdL <> Nil
                                 then
                                   begin
                                     SHGetPathFromIDList(pIdL,BufferChemin);
                                     RECHERCHE_RECURSIVE(BufferChemin);
                                     Memory^.Vtbl^.Free(Memory,pIdL);
                                   end
                                 else
                                   WriteLn('   Erreur (SHGetPathFromIDList)');
                              Memory^.Vtbl^.Release(Memory);
                            end
                          else
                            WriteLn('   Erreur (SHGetSpecialFolderLocation)');
                       (* 2. GROUPE DE PROGRAMMES *)
                       WriteLn('-------------------------');
                       WriteLn(' 2. Groupe de programmes ');
                       WriteLn('-------------------------');
                       Memory := Nil;
                       pIdL := Nil;
                       if SHGetMalloc(@Memory) = NOERROR
                          then
                            begin
                              SHGetSpecialFolderLocation(0,CSIDL_PROGRAMS,pIdL);
                              if pIdL <> Nil
                                 then
                                   begin
                                     SHGetPathFromIDList(pIdL,BufferChemin);
                                     RECHERCHE_RECURSIVE(BufferChemin);
                                     Memory^.Vtbl^.Free(Memory,pIdL);
                                   end
                                 else
                                   WriteLn('   Erreur (SHGetPathFromIDList)');
                              Memory^.Vtbl^.Release(Memory);
                            end
                          else
                            WriteLn('   Erreur (SHGetSpecialFolderLocation)');
                       (* 3. MENU DEMARRER *)
                       WriteLn('------------------');
                       WriteLn(' 3. Menu d'#233'marrer ');
                       WriteLn('------------------');
                       Memory := Nil;
                       pIdL := Nil;
                       if SHGetMalloc(@Memory) = NOERROR
                          then
                            begin
                              SHGetSpecialFolderLocation(0,CSIDL_STARTMENU,pIdL);
                              if pIdL <> Nil
                                 then
                                   begin
                                     SHGetPathFromIDList(pIdL,BufferChemin);
                                     RECHERCHE_RECURSIVE(BufferChemin);
                                     Memory^.Vtbl^.Free(Memory,pIdL);
                                   end
                                 else
                                   WriteLn('   Erreur (SHGetPathFromIDList)');
                              Memory^.Vtbl^.Release(Memory);
                            end
                          else
                            WriteLn('   Erreur (SHGetSpecialFolderLocation)');
                       (* 4. DOCUMENTS RECENTS *)
                       WriteLn('----------------------');
                       WriteLn(' 4. Documents r'#233'cents ');
                       WriteLn('----------------------');
                       Memory := Nil;
                       pIdL := Nil;
                       if SHGetMalloc(@Memory) = NOERROR
                          then
                            begin
                              SHGetSpecialFolderLocation(0,CSIDL_RECENT,pIdL);
                              if pIdL <> Nil
                                 then
                                   begin
                                     SHGetPathFromIDList(pIdL,BufferChemin);
                                     RECHERCHE_RECURSIVE(BufferChemin);
                                     Memory^.Vtbl^.Free(Memory,pIdL);
                                   end
                                 else
                                   WriteLn('   Erreur (SHGetPathFromIDList)');
                              Memory^.Vtbl^.Release(Memory);
                            end
                          else
                            WriteLn('   Erreur (SHGetSpecialFolderLocation)');
                       (* 5. SEND TO *)
                       WriteLn('--------------------');
                       WriteLn(' 5. Envoyer vers... ');
                       WriteLn('--------------------');
                       Memory := Nil;
                       pIdL := Nil;
                       if SHGetMalloc(@Memory) = NOERROR
                          then
                            begin
                              SHGetSpecialFolderLocation(0,CSIDL_SENDTO,pIdL);
                              if pIdL <> Nil
                                 then
                                   begin
                                     SHGetPathFromIDList(pIdL,BufferChemin);
                                     RECHERCHE_RECURSIVE(BufferChemin);
                                     Memory^.Vtbl^.Free(Memory,pIdL);
                                   end
                                 else
                                   WriteLn('   Erreur (SHGetPathFromIDList)');
                              Memory^.Vtbl^.Release(Memory);
                            end
                          else
                            WriteLn('   Erreur (SHGetSpecialFolderLocation)');
                       (* 6. GROUPE DE PROGRAMMES DE DEMARRAGE *)
                       WriteLn('-------------------------------------');
                       WriteLn(' 6. Groupe de programmes de d'#233'marrage');
                       WriteLn('-------------------------------------');
                       Memory := Nil;
                       pIdL := Nil;
                       if SHGetMalloc(@Memory) = NOERROR
                          then
                            begin
                              SHGetSpecialFolderLocation(0,CSIDL_STARTUP,pIdL);
                              if pIdL <> Nil
                                 then
                                   begin
                                     SHGetPathFromIDList(pIdL,BufferChemin);
                                     RECHERCHE_RECURSIVE(BufferChemin);
                                     Memory^.Vtbl^.Free(Memory,pIdL);
                                   end
                                 else
                                   WriteLn('   Erreur (SHGetPathFromIDList)');
                              Memory^.Vtbl^.Release(Memory);
                            end
                          else
                            WriteLn('   Erreur (SHGetSpecialFolderLocation)');
{
                       StrCopy(BufferChemin,'E:');
                       RECHERCHE_RECURSIVE(BufferChemin);
}
                       PF^.Vtbl^.Release(PF);
                       SetCursor(AncienCurseur);
                     end
                   else
                     WriteLn('Erreur');
                SL^.Vtbl^.Release(SL);
              end
            else
              WriteLn('Erreur');
         CoUninitialize;
       end
     else
       WriteLn('Erreur');
  WriteLn;
  Write('Pressez Enter pour fermer le programme...');
  ReadLn;
  DoneWinCRT;
END.

